<?php

include('config.php');

$city = isset($_GET['city']) ? htmlspecialchars($_GET['city'], ENT_QUOTES, 'UTF-8') : '';
$country = isset($_GET['country']) ? htmlspecialchars($_GET['country'], ENT_QUOTES, 'UTF-8') : ''; 

$cityData = [];

if ($city) {
    // Correct SQL statement
    $sql = "SELECT city, country FROM city WHERE city = ?";
    $stmt = $conn->prepare($sql);

    // Bind parameters
    $stmt->bind_param("s", $city);
    $stmt->execute();

    $result = $stmt->get_result();
    
    if ($result->num_rows > 0) {
        $cityData = $result->fetch_assoc();
    }
    
    $stmt->close();
}

$conn->close();

// Correct the variable used for country name
$cityName = isset($cityData['city']) ? $cityData['city'] : "not found";
$countryName = isset($cityData['country']) ? $cityData['country'] : "not found";

?>




 <!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Vegetable Supplier & Exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>
</title>
    <meta content="width=device-width, initial-scale=1.0" name="viewport">
    <meta name="keywords" content="Vegetable Supplier in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>, Vegetable Exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>">
    <meta name="description" content="Explore the natural goodness of trusted  Vegetable Suppliers and exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>'s . Pure, sustainable, and packed with health benefits.">
    <link rel="canonical"href="https://mkexport.co.in/-honey.php">
  <meta name="robots" content="index, follow" />
  
  <!-- HTML Meta Tags -->
<title>Vegetable Supplier & Exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>
</title>
<meta name="description" content="Explore the natural goodness of trusted  Vegetable Suppliers and exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>'s . Pure, sustainable, and packed with health benefits.">

<!-- Facebook Meta Tags -->
<meta property="og:url" content="https://mkexport.co.in/-honey.php">
<meta property="og:type" content="website">
<meta property="og:title" content="Vegetable Supplier & Exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>
">
<meta property="og:description" content="Explore the natural goodness of trusted  Vegetable Suppliers and exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>'s . Pure, sustainable, and packed with health benefits.">
<meta property="og:image" content="https://5.imimg.com/data5/SELLER/Default/2021/6/AM/LA/DK/55708315/nutriwish-raw--honey-500x500.jpeg">

<!-- Twitter Meta Tags -->
<meta name="twitter:card" content="summary_large_image">
<meta property="twitter:domain" content="mkexport.co.in">
<meta property="twitter:url" content="https://mkexport.co.in/-honey.php">
<meta name="twitter:title" content="Vegetable Supplier & Exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>
">
<meta name="twitter:description" content="Explore the natural goodness of trusted  Vegetable Suppliers and exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>'s . Pure, sustainable, and packed with health benefits.">
<meta name="twitter:image" content="https://5.imimg.com/data5/SELLER/Default/2021/6/AM/LA/DK/55708315/nutriwish-raw--honey-500x500.jpeg">

<!-- Meta Tags Generated via https://www.opengraph.xyz -->
  <!-- Bootstrap CSS -->
  <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
  <!-- Font Awesome -->
  <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css" rel="stylesheet">
  <style>
    /* Custom CSS */
    .product-section {
      margin-top: 50px; /* Adjust as needed */
    }
    .card .icon {
      font-size: 48px;
      margin-bottom: 20px;
    }
  </style>
  
  <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
  
  <script type="application/ld+json">
{
  "@context": "https://schema.org/", 
  "@type": "Product", 
  "name": "Vegetable",
  "image": "https://5.imimg.com/data5/SELLER/Default/2021/6/AM/LA/DK/55708315/nutriwish-raw--honey-500x500.jpeg",
  "description": "Explore the natural goodness of trusted Vegetable Suppliers and exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>'s . Pure, sustainable, and packed with health benefits.",
  "brand": {
    "@type": "Brand",
    "name": "MK Export"
  },
  "aggregateRating": {
    "@type": "AggregateRating",
    "ratingValue": "5",
    "bestRating": "5",
    "worstRating": "5",
    "ratingCount": "100"
  }
}
</script>
</head>
<body>

 
  <?php include('header.php'); ?>
 
    <style>
        .lancer-about {
            margin-top: 150px;
        }
        .img-shadow {
            border-radius: 10px;
            box-shadow: 0 0 30px rgba(0, 0, 0, 0.4);
        }
        .reasons-section {
            background-color: #f8f9fa;
            padding: 50px 0;
        }
        .reasons-section h2 {
            text-align: center;
            margin-bottom: 40px;
            font-weight: bold;
            color: #343a40;
        }
        .reason-card {
            background-color: white;
            border: none;
            box-shadow: 0 4px 8px rgba(0,0,0,0.1);
            margin-bottom: 30px;
            padding: 20px;
            border-radius: 8px;
            transition: transform 0.2s;
        }
        .reason-card:hover {
            transform: translateY(-10px);
        }
        .reason-card .icon {
            font-size: 48px;
            color: #17a2b8;
            margin-bottom: 20px;
        }
        .reason-card h5 {
            font-weight: bold;
            color: #343a40;
            margin-bottom: 10px;
        }
        .reason-card p {
            color: #6c757d;
        }
        .custom-paragraph {
            font-size: 18px;
            color: black;
            padding: 10px;
            border-left: 5px solid rgb(162, 187, 59);
            margin-left: 5px;
        }
        .conclusion-section {
            padding: 50px 0;
            background-color: #e9ecef;
            text-align: center;
        }
        .conclusion-section h2 {
            font-weight: bold;
            color: #343a40;
            margin-bottom: 20px;
        }
        .conclusion-section p {
            color: #6c757d;
            font-size: 18px;
            margin-bottom: 0;
        }
        .breadcrumb {
    position: relative;
    display: flex;
    flex-wrap: wrap;
    padding: 48px 57px;
    justify-content: center;
    margin-bottom: 1rem;
    list-style: none;
    background: url('https://cdn.britannica.com/17/196817-159-9E487F15/vegetables.jpg') no-repeat center center / cover;
}

.breadcrumb::before {
    content: '';
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background: #15b9d98a;
    z-index: 1;
}

.breadcrumb > * {
    position: relative;
    z-index: 2;
}

@media (min-width: 1200px) {
    .container-xl, .container-lg, .container-md, .container-sm, .container {
        max-width: 100%;
    }
}

    </style>
</head>
<body>
    
   <nav style="--bs-breadcrumb-divider: url(&#34;data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='8' height='8'%3E%3Cpath d='M2.5 0L1 1.5 3.5 4 1 6.5 2.5 8l4-4-4-4z' fill='currentColor'/%3E%3C/svg%3E&#34;);" aria-label="breadcrumb">
  <ol class="breadcrumb">
    <li class="breadcrumb-item"><a href="/">Home</a></li>
    <li class="breadcrumb-item active text-white" aria-current="page">Vegetable</li>
  </ol>
</nav>
    
    <section class="">
        <div class="container">
            <div class="row" style="margin-top:100px;">
                <div class="col-md-6">
                    <img src="https://www.healthyeating.org/images/default-source/home-0.0/nutrition-topics-2.0/general-nutrition-wellness/2-2-2-2foodgroups_vegetables_detailfeature.jpg?sfvrsn=226f1bc7_6"alt="Vegetable Supplier in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>"title="Vegetable Supplier in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>" height="400px" width="auto" class="img-fluid img-shadow">
                </div>
                <div class="col-md-6">
                    <div class="chart-block">
                        <header class="page-heading text-left">
                            <h1>Vegetable Supplier & Exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?><span class="add"></span></h1>
                        </header>
                        <p class="custom-paragraph">
                            There's something magical about the amber hue of Vegetable, isn't there? It's like a ray of sunshine captured in a jar, radiating sweetness and purity. As the leading Vegetable Exporter in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?> and Vegetable Supplier in <?php echo htmlspecialchars($cityName, ENT_QUOTES, 'UTF-8'); ?>, we take pride in offering you this exquisite nectar straight from the heart of nature.</p>
                    </div>
                </div>
            </div>
            
             <?php include('footer.php');?>